CREATE PROCEDURE CMS_ForeignKeyFinder
AS

SELECT        REF_CONST.CONSTRAINT_NAME, FK.TABLE_CATALOG, FK.TABLE_SCHEMA, FK.TABLE_NAME, FK_COLS.COLUMN_NAME, 
                         PK.TABLE_CATALOG AS REFERENCED_TABLE_CATALOG, PK.TABLE_SCHEMA AS REFERENCED_TABLE_SCHEMA, 
                         PK.TABLE_NAME AS REFERENCED_TABLE_NAME, PK_COLS.COLUMN_NAME AS REFERENCED_COLUMN_NAME
FROM            INFORMATION_SCHEMA.REFERENTIAL_CONSTRAINTS AS REF_CONST INNER JOIN
                         INFORMATION_SCHEMA.TABLE_CONSTRAINTS AS FK ON REF_CONST.CONSTRAINT_CATALOG = FK.CONSTRAINT_CATALOG AND 
                         REF_CONST.CONSTRAINT_SCHEMA = FK.CONSTRAINT_SCHEMA AND REF_CONST.CONSTRAINT_NAME = FK.CONSTRAINT_NAME AND 
                         FK.CONSTRAINT_TYPE = 'FOREIGN KEY' INNER JOIN
                         INFORMATION_SCHEMA.TABLE_CONSTRAINTS AS PK ON REF_CONST.UNIQUE_CONSTRAINT_CATALOG = PK.CONSTRAINT_CATALOG AND 
                         REF_CONST.UNIQUE_CONSTRAINT_SCHEMA = PK.CONSTRAINT_SCHEMA AND REF_CONST.UNIQUE_CONSTRAINT_NAME = PK.CONSTRAINT_NAME AND 
                         PK.CONSTRAINT_TYPE = 'PRIMARY KEY' INNER JOIN
                         INFORMATION_SCHEMA.KEY_COLUMN_USAGE AS FK_COLS ON REF_CONST.CONSTRAINT_NAME = FK_COLS.CONSTRAINT_NAME INNER JOIN
                         INFORMATION_SCHEMA.KEY_COLUMN_USAGE AS PK_COLS ON PK.CONSTRAINT_NAME = PK_COLS.CONSTRAINT_NAME